Bug 850789 - Review Request: babeld - Ad-hoc network routing daemon
Review Request: babeld - Ad-hoc network routing daemon
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Michael Scherer
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-08-22 08:31 EDT by Gwyn Ciesla
Modified: 2012-09-17 17:55 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-09-07 07:23:45 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
misc: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Gwyn Ciesla 2012-08-22 08:31:39 EDT
Description:
Babel is a loop-avoiding distance-vector routing protocol roughly
based on HSDV and AODV, but with provisions for link cost estimation
and redistribution of routes from other routing protocols.

SPEC: http://fedorapeople.org/~limb/review/babeld/babeld.spec
SRPM: http://fedorapeople.org/~limb/review/babeld/babeld-1.3.4-1.fc17.src.rpm
Comment 1 Michael Scherer 2012-08-22 17:44:52 EDT
Hi, 

I have a few comments :

- this Requires seems uneeded :
Requires(post): systemd-sysv

Afaik, the %post do not seems to use this.


- there is lots of thing that would be removed for a non epel rpm, like %defattr, %clean, etc, since the package only ship systemd file, I think this is better to remove old stuff :

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
rm -rf $RPM_BUILD_ROOT  in %install and %clean


- I would also recommend the macro for systemd %post/%postun 

- using a joker could help for futureproofing ( if the manpage compression is changed ) :
%{_mandir}/man8/babeld.8.gz

- policy recommend to use %global instead of %define 

- it would also be more consistent to alway use %name ( sometime, there is %name.service, sometimes babeld.service ) 


Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



===== MUST items =====

C/C++:
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Permissions on files are set properly.
[x]: Package does not contain duplicates in %files.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
[x]: Large documentation files are in a -doc subpackage, if required.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "MIT/X11 (BSD like)" For detailed output of licensecheck see file:
     /home/misc/checkout/git/FedoraReview/850789-babeld/licensecheck.txt
[!]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: No %config files under /usr.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[!]: Requires correct, justified where necessary.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Useful -debuginfo package or justification otherwise.

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[!]: Buildroot is not present
     Note: Buildroot is not needed unless packager plans to package for EPEL5
[!]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL5
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[!]: Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files section. This is OK if packaging
     for EPEL5. Otherwise not needed
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX / PatchY prefixed with %{name}.
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[!]: Spec use %global instead of %define.
     Note: %define _hardened_build 1

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.

Issues:
=======
[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
See: None
[!]: Requires correct, justified where necessary.
Requires(post) systemd-sysv
[!]: Package consistently uses macro

Rpmlint
-------
Checking: babeld-1.3.4-1.fc17.x86_64.rpm
          babeld-1.3.4-1.fc17.src.rpm
          babeld-debuginfo-1.3.4-1.fc17.x86_64.rpm
babeld.x86_64: W: spelling-error Summary(en_US) hoc -> ho, choc, hock
babeld.x86_64: W: only-non-binary-in-usr-lib
babeld.src: W: spelling-error Summary(en_US) hoc -> ho, choc, hock
3 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
babeld-1.3.4-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /bin/sh  
    config(babeld) = 1.3.4-1.fc17
    libc.so.6()(64bit)  
    librt.so.1()(64bit)  
    rtld(GNU_HASH)  
    systemd-sysv  
    systemd-units  

babeld-debuginfo-1.3.4-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    



Provides
--------
babeld-1.3.4-1.fc17.x86_64.rpm:
    
    babeld = 1.3.4-1.fc17
    babeld(x86-64) = 1.3.4-1.fc17
    config(babeld) = 1.3.4-1.fc17

babeld-debuginfo-1.3.4-1.fc17.x86_64.rpm:
    
    babeld-debuginfo = 1.3.4-1.fc17
    babeld-debuginfo(x86-64) = 1.3.4-1.fc17



MD5-sum check
-------------
http://www.pps.univ-paris-diderot.fr/~jch/software/files/babeld-1.3.4.tar.gz :
  CHECKSUM(SHA256) this package     : 818cf9e8e4f7ee297a34190a2179bae9aa4c704791739699c1e1496ad02354df
  CHECKSUM(SHA256) upstream package : 818cf9e8e4f7ee297a34190a2179bae9aa4c704791739699c1e1496ad02354df


Generated by fedora-review 0.2.0 (a5c4ced) last change: 2012-07-22
Command line :./try-fedora-review -v -b 850789
External plugins:
Comment 2 Michael Scherer 2012-08-22 18:11:43 EDT
Additional comment :

The software also do not seems to have a configuration file, while the manpage speak of /etc/babeld.conf. Could a default one shipped ?

There is also mention of /var/lib/babel-state , and maybe using %ghost could be a idea for this one. ( ie, to not let leftover on removal )

last, the log go to /var/lob/babel.log, so i think that should requires a logrotate file.
Comment 3 Gwyn Ciesla 2012-08-23 09:43:30 EDT
I've started with the above from #1.  Re #2, that's why I included the sysconfig file, since there isn't a default example shipped by upstream.  I'll make one up, as well as the log and state bits.
Comment 4 Gwyn Ciesla 2012-08-23 17:10:07 EDT
SPEC: http://fedorapeople.org/~limb/review/babeld/babeld.spec
SRPM: http://fedorapeople.org/~limb/review/babeld/babeld-1.3.4-1.fc17.src.rpm

Fixed most of the above.  Leaving the systemd macros alone for now since I want this in all current Fedora branches, not just 18+.
Comment 5 Michael Scherer 2012-08-24 05:25:11 EDT
Since babel-state is changed during operation, shouldn't it marked as nomd5, or something like that ?

And you didn't update the srpm in the link
Comment 6 Gwyn Ciesla 2012-08-24 07:27:52 EDT
SPEC: http://fedorapeople.org/~limb/review/babeld/babeld.spec
SRPM: http://fedorapeople.org/~limb/review/babeld/babeld-1.3.4-2.fc17.src.rpm

I ghosted it instead.  And updated. :)
Comment 7 Michael Scherer 2012-08-27 13:38:10 EDT
Ok, so I checked, the point noted were fixed, and I tested, it compile and start fine, so approved.
Comment 8 Gwyn Ciesla 2012-08-27 13:45:34 EDT
Sweet, thanks very much!

New Package SCM Request
=======================
Package Name: babeld
Short Description: Ad-hoc network routing daemon
Owners: limb
Branches: f16 f17 f18
InitialCC:
Comment 9 Gwyn Ciesla 2012-08-27 13:47:15 EDT
Git done (by process-git-requests).
Comment 10 Fedora Update System 2012-08-27 14:37:49 EDT
babeld-1.3.4-2.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/babeld-1.3.4-2.fc17
Comment 11 Fedora Update System 2012-08-27 14:38:01 EDT
babeld-1.3.4-2.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/babeld-1.3.4-2.fc16
Comment 12 Fedora Update System 2012-08-27 14:38:11 EDT
babeld-1.3.4-2.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/babeld-1.3.4-2.fc18
Comment 13 Fedora Update System 2012-08-28 14:13:30 EDT
babeld-1.3.4-2.fc18 has been pushed to the Fedora 18 testing repository.
Comment 14 Michael Scherer 2012-08-28 16:12:44 EDT
Someone at work notified me that quagga already ship babel support, so there is a file conflict I missed. As a side note, maybe babeld is not so useful if there is already support in quagga ( even if I can understand that using babeld standalone would be easier than babeld + quagga )
Comment 15 Gwyn Ciesla 2012-08-28 16:20:05 EDT
I think it's inclusion is warranted, for those not wanting to use quagga.  Which files conflict?
Comment 16 Michael Scherer 2012-08-28 17:09:07 EDT
File conflict :

/lib/systemd/system/babeld.service
/usr/sbin/babeld

What annoy me is the huge code duplication, in fact.
Comment 17 Gwyn Ciesla 2012-08-29 10:56:51 EDT
Given that this is the referece implementation, it seems like having quagga rename theirs would be preferable.  WRT duplication, is it really duplication?  My understanding was that quagga's was a separate implementation of the protocol.
Comment 18 Michael Scherer 2012-08-29 11:08:27 EDT
That's the same upstream in both case, and while I didn't check the code, I understand this mail as "I took my code and put it in quagga" :

http://lists.quagga.net/pipermail/quagga-dev/2012-February/009122.html

But the easiest IMHO would be to either split quagga in sub package and conflict with quagga-babeld, or just conflict with quagga as a whole. 

renaming everything would likely introduce various breakage.
Comment 19 Gwyn Ciesla 2012-08-29 11:15:59 EDT
<headdesk>

Adding quagga maintainer.

Adam, would you be averse to splitting out quagga's babeld into quagga-babeld so I can Conflict with just that, in case people want to use quagga and babeld but not quagga's babeld?  Or should I just conflict with quagga?
Comment 20 Adam Tkac 2012-09-03 14:08:19 EDT
(In reply to comment #19)
> <headdesk>
> 
> Adding quagga maintainer.
> 
> Adam, would you be averse to splitting out quagga's babeld into
> quagga-babeld so I can Conflict with just that, in case people want to use
> quagga and babeld but not quagga's babeld?  Or should I just conflict with
> quagga?

In my opinion it doesn't make much sence to use two different routing daemons on one machine, does it? I would prefer to just conflict with quagga.
Comment 21 Gwyn Ciesla 2012-09-04 09:44:09 EDT
I can imagine a few bizaare corner cases, possibly involving virtualization, multiple interfaces and subnets, and dark magic, but in that case simply using quagga's babeld is probably the desirable course of action.


I'll Conflict with quagga in f18+.  Thanks Adam!
Comment 22 Fedora Update System 2012-09-07 07:23:45 EDT
babeld-1.3.4-2.fc16 has been pushed to the Fedora 16 stable repository.
Comment 23 Fedora Update System 2012-09-07 07:32:55 EDT
babeld-1.3.4-2.fc17 has been pushed to the Fedora 17 stable repository.
Comment 24 Fedora Update System 2012-09-17 17:55:26 EDT
babeld-1.3.4-2.fc18 has been pushed to the Fedora 18 stable repository.

Note You need to log in before you can comment on or make changes to this bug.